/*********************************************************************************************************
*
* File                : TouchPanel.h
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM  Version: 4.20
* Version             : V1.0
* By                  : 
*
*                                  (c) Copyright 2005-2011, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

#ifndef _TOUCHPANEL_H_
#define _TOUCHPANEL_H_

#include "LPC4357_IO.h"
#include "LCD.h"


/* Private typedef -----------------------------------------------------------*/
typedef	struct POINT 
{
   uint16_t x;
   uint16_t y;
}Coordinate;

typedef struct Matrix 
{						
long double An,  
            Bn,     
            Cn,   
            Dn,    
            En,    
            Fn,     
            Divider ;
} Matrix ;



/* Private define ------------------------------------------------------------*/
#define THRESHOLD 2


/* Private define ------------------------------------------------------------*/

#define	CHX 	0x90
#define	CHY 	0xD0


#define LCD_7INCH_TouchPanel_nCS_L      GPIO_ClearValue(LCD_7INCH_Touch_CS_GPIO_PORT,(1<<LCD_7INCH_Touch_CS_GPIO_BIT));
#define LCD_7INCH_TouchPanel_nCS_H      GPIO_SetValue(LCD_7INCH_Touch_CS_GPIO_PORT,(1<<LCD_7INCH_Touch_CS_GPIO_BIT));	


#define LCD_43INCH_TouchPanel_nCS_L      GPIO_ClearValue(LCD_43INCH_Touch_CS_GPIO_PORT,(1<<LCD_43INCH_Touch_CS_GPIO_BIT));
#define LCD_43INCH_TouchPanel_nCS_H      GPIO_SetValue(LCD_43INCH_Touch_CS_GPIO_PORT,(1<<LCD_43INCH_Touch_CS_GPIO_BIT));

#ifdef LCD_43INCH
	#define TouchPanel_Enable 	 LCD_43INCH_TouchPanel_nCS_L
	#define TouchPanel_Disable 	 LCD_43INCH_TouchPanel_nCS_H
#else 
	#define TouchPanel_Enable 		LCD_7INCH_TouchPanel_nCS_L
	#define TouchPanel_Disable 		LCD_7INCH_TouchPanel_nCS_H
#endif

												
/*PERIQ -> P2_15*/
#define TP_INT_IN           (GPIO_ReadValue(Touch_IRQ_GPIO_PORT) & (1<<Touch_IRQ_GPIO_BIT))
#define BUSY_INT_IN           (GPIO_ReadValue(Touch_BUSY_GPIO_PORT) & (1<<Touch_BUSY_GPIO_BIT))



void delay_ms(uint32_t ms);



//uint8_t SPI_WriteByte(uint8_t  data);


void SSPI1_Init(void);
//Coordinate *TP_GetAdXY(uint32_t *x,uint32_t *y);
void touch_init(void);
Coordinate * Read_XTP2046(void);

void TouchPanel_Calibrate(void);
void TouchPanel_Calibrate2(void);

void DrawCross(uint16_t Xpos,uint16_t Ypos);
void TP_DrawPoint(uint16_t Xpos,uint16_t Ypos);
FunctionalState setCalibrationMatrix( Coordinate * displayPtr,Coordinate * screenPtr,Matrix * matrixPtr);
FunctionalState getDisplayPoint(Coordinate * displayPtr,Coordinate * screenPtr,Matrix * matrixPtr );
void TP_DrawPoint(uint16_t Xpos,uint16_t Ypos);



#endif  /*_TOUCHPANEL_H_*/

